// Procedures for WebResearch Firefox extension
// macropool GmbH, 2006-2011
// All rights reserved

var gDoc = null;

// ScrapBook stuff
var gScrapBookisInstalled = false;
var gScrapBookFolder = '';
var gScrapBookPath = '';
var gDocType = 0;
var gSaveType = 0;
var gURL2 = '';
var gTitle = '';

window.removeEventListener("load", initWebResearch, true);
window.addEventListener("load", initWebResearch, true);

function initWebResearch(event)
{
	
	//var page = event.originalTarget; //defaultView
	//alert(page.location.href);

	// window.removeEventListener("load",onloadlistener,true);
	// doc that has loaded can be retrieved via event.originalTarget
	// document.getElementById("appcontent").addEventListener("load", onloadprocessing, true);
	/*
	var tb = document.getElementById("content");
	if (tb) {
		tb.addEventListener("load", onloadprocessing, true);
	}
	*/


	// Kontextmenue einklinken
	var menu = document.getElementById("contentAreaContextMenu");
	menu.removeEventListener("popupshowing", ShowHideWRContextMenu, true);
	menu.addEventListener("popupshowing",    ShowHideWRContextMenu, true);
}

function ShowHideWRContextMenu()
{
	document.getElementById("cmdSaveSelection").hidden = true;
	document.getElementById("cmdSaveSelectionAs").hidden = true;
	document.getElementById("cmdSaveFrame").hidden = true;
	document.getElementById("cmdSaveFrameAs").hidden = true;
	document.getElementById("cmdSavePicture").hidden =  true;
	document.getElementById("cmdSavePictureAs").hidden = true;
	document.getElementById("cmdSaveTarget").hidden = true;
	document.getElementById("cmdSaveTargetAs").hidden = true;
	document.getElementById("cmdSaveAddressAs").hidden = true;

	if (gContextMenu.onImage == true) {

		document.getElementById("cmdSavePicture").hidden = false;
		document.getElementById("cmdSavePictureAs").hidden = false;
		
		if ((gContextMenu.onLink == true) && (gContextMenu.onMailtoLink == false)) {
			document.getElementById("cmdSaveAddressAs").hidden = false;
			document.getElementById("cmdSaveTarget").hidden = false;
			document.getElementById("cmdSaveTargetAs").hidden = false;
		}
	} else {
		if (gContextMenu.isTextSelected == true) {
			document.getElementById("cmdSaveSelection").hidden = false;
			document.getElementById("cmdSaveSelectionAs").hidden = false;
		} else {
			if ((gContextMenu.onLink == true) && (gContextMenu.onMailtoLink == false)) {
				document.getElementById("cmdSaveTarget").hidden = false;
				document.getElementById("cmdSaveTargetAs").hidden = false;
				document.getElementById("cmdSaveAddressAs").hidden = false;			
			} else {
				document.getElementById("cmdSaveFrame").hidden = false;
				document.getElementById("cmdSaveFrameAs").hidden = false;			
			}
		}
	}
}


WebResearch = {

    SBOnCaptureComplete: function() { },

    StartWRApp: function() {
        var path = '';
        var subkey = null;
        var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
        wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\macropool", wrk.ACCESS_READ);
        if (wrk.hasChild("WebResearch")) {
            subkey = wrk.openChild("WebResearch", wrk.ACCESS_READ)
        }
        if (subkey == null) {
            wrk.close();
            var bundle1 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
            var localizedString1 = bundle1.GetStringFromName("wr3missing");
            alert(localizedString1);
            return;
        }

        var AppPath = subkey.readStringValue("AppPath");
        wrk.close();
        AppPath = AppPath + 'WRApp.exe';
        // netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        try {
            var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath(AppPath);
            var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
            process.init(file);
            // run ( PRBool blocking , arrayof char* args , PRUint32 count ) 
            var args = ["/NoSplash"];
            process.runw(false, args, args.length);
        } catch (e) {
            alert(e);
        }
    },

     
    PrepareSaving: function() {

        // find WebResearch installation directory
        var path = '';
        var subkey = null;
        var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
        wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\macropool", wrk.ACCESS_READ);
        if (wrk.hasChild("WebResearch")) {
            subkey = wrk.openChild("WebResearch", wrk.ACCESS_READ)
        }
        if (subkey == null) {
            wrk.close();
            var bundle1 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
            var localizedString1 = bundle1.GetStringFromName("wr3missing");
            alert(localizedString1);
            return 1;
        }

        if (subkey.hasValue("Firefox7Compatible")) {
          wrk.close();
        } else {  
          wrk.close();
          var bundle2 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
          var localizedString2 = bundle2.GetStringFromName("wr3updaterequired");
          alert(localizedString2);
          window.open(bundle2.GetStringFromName("wr3updatedownloadurl"));
          return 1;
        }

        gDocType = 0;
        gSaveType = 0;
        gTitle = '';
        
        var TabBrowser = document.getElementById("content");
        var browser = TabBrowser.selectedBrowser

        var url = browser.currentURI.spec;
        gURL2 = url;
        
        if ((!url) || (url == '') || (url == 'about:blank')) {
            // blank
            return 1;
        }

        // If control gets here, we have a non-Null browser	
        gDoc = browser.webNavigation.document;
        url = gDoc.location.href;
        if (url.indexOf('.pdf') > 0) {
            gScrapBookisInstalled = false;
            return;
        }

        // check if ScrapBook is installed
        gScrapBookisInstalled = document.getElementById("ScrapBookMenubarItem4WR");
        if (gScrapBookisInstalled) {

            // Pruefen, ob noch evtl. ein altes Scrapbook installiert ist.
            var OldScrapBookisInstalled = false;
            OldScrapBookisInstalled = document.getElementById("ScrapBookMenubarItem1");
            if (OldScrapBookisInstalled) {
                var bundle = srGetStrBundle("chrome://WebResearch/locale/names.properties");
                var localizedString = bundle.GetStringFromName("scrapbookerrormessage");
                alert(localizedString);
                window.open(bundle.GetStringFromName("scrapbookdownloadurl"));
                gScrapBookisInstalled = false;
                return 1;
            }
            
            // check if "Web Research" Folder is present in ScrapBook
            var gMyPrefs = new PrefsWrapper1("extensions.webresearch@macropool.com.");
            var aTargetID = gMyPrefs.getUnicharPrefDef("scrapbook", "");
            var sbFolderExists = false;

            // should be something like 'urn:scrapbook:item20070611131818'
            aTargetID = sbBrowserOverlay.verifyTargetID(aTargetID);

            if (aTargetID.indexOf("urn:scrapbook:root") == 0) {
                sbFolderExists = false;
            } else {
                var aID = '';
                var b = aTargetID.indexOf("urn:scrapbook:item");
                if (b == 0) {
                    aID = aTargetID.substring(18);
                }
                // check if folder exists
                sbDataSource.init();
                sbFolderExists = sbDataSource.exists(aID);
                if (sbFolderExists)
                    gScrapBookFolder = aTargetID;
            }

            if (sbFolderExists == false) {
                // create webResearch folder below root
                var newID = sbDataSource.identify(sbCommonUtils.getTimeStamp());
                var newItem = sbCommonUtils.newItem(newID);
                newItem.title = "Web Research";
                newItem.type = "folder";
                var newRes = sbDataSource.addItem(newItem, "urn:scrapbook:root", 0);
                sbDataSource.createEmptySeq(newRes.Value);
                // save last used folder
                gMyPrefs.setUnicharPref("scrapbook", newRes.Value);
                gScrapBookFolder = newRes.Value;
            }
        } else {
            // WebResearch ScrapBook-Erweiterung ist nicht installiert.
            // Jetzt pruefen, ob noch ein altes ScrapBook installiert ist.
            var bundle1 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
            var OtherScrapBookIsInstalled = false;
            OtherScrapBookIsInstalled = document.getElementById("ScrapBookMenubarItem1");
            if (OtherScrapBookIsInstalled) {
              var localizedString1 = bundle1.GetStringFromName("scrapbookerrormessage");
            } else {
              var localizedString1 = bundle1.GetStringFromName("scrapbookmissingmessage");
            }
            alert(localizedString1);
            window.open(bundle1.GetStringFromName("scrapbookdownloadurl"));
        }
    },

    
    SaveSelection: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        // get focused window
        var myWindow = document.commandDispatcher.focusedWindow;
        if (!myWindow || myWindow == window) myWindow = window._content;
        var doc = myWindow.document;
        var sel = myWindow.getSelection();
        var title = sel.toString();

        var index = title.indexOf("\n");
        if (index > 0)
            title = title.substring(0, index);
        else
            title = title.substring(0, 80);
        title = title.replace(/"/g, "'");
              
        if (gScrapBookisInstalled) {
            gDocType = 101;
            gTitle = title;
            this.SaveWithScrapBook(false, true);
        }
        else {
            var bundle1 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
            var localizedString1 = bundle1.GetStringFromName("scrapbookmissingsaveselection");
            alert(localizedString1);
        }
    },


    SaveSelectionAs: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        // get focused window
        var myWindow = document.commandDispatcher.focusedWindow;
        if (!myWindow || myWindow == window) myWindow = window._content;
        var doc = myWindow.document;
        var sel = myWindow.getSelection();
        var title = sel.toString();

        var index = title.indexOf("\n");
        if (index > 0)
            title = title.substring(0, index);
        else
            title = title.substring(0, 80);
        title = title.replace(/"/g, "'");

        if (gScrapBookisInstalled) {
            gSaveType = 4;
            gDocType = 101;
            gTitle = title;
            this.SaveWithScrapBook(false, true);
        }
        else {
            var bundle1 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
            var localizedString1 = bundle1.GetStringFromName("scrapbookmissingsaveselection");
            alert(localizedString1);
        }
    },


    StartWRSaver: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        var path = '';
        var subkey = null;
        var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
        wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\macropool", wrk.ACCESS_READ);
        if (wrk.hasChild("WebResearch")) {
            subkey = wrk.openChild("WebResearch", wrk.ACCESS_READ)
        }
        if (subkey == null) {
            wrk.close();
            var bundle1 = srGetStrBundle("chrome://WebResearch/locale/names.properties");
            var localizedString1 = bundle1.GetStringFromName("wr3missing");
            alert(localizedString1);
            return;
        }

        var AppPath = subkey.readStringValue("AppPath");
        wrk.close();
        AppPath = AppPath + 'WRSaver.exe';
        //
        // netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        try {
            var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath(AppPath);
            var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
            process.init(file);
            // run ( PRBool blocking , arrayof char* args , PRUint32 count ) 
            var args = ["/Url:" + gURL2];
            process.runw(false, args, args.length);
        } catch (e) {
            alert(e);
        }
    },


    SaveOneClick: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }
        
        var Frames = gDoc.getElementsByTagName('FRAME');
        var FrameCount = Frames.length;
        if (FrameCount > 0) {
            var obj = new Object();
            obj.result = "";
            window.openDialog("chrome://webresearch/content/frames.xul", 'foo_main', "chrome,dialog=yes,close,modal=yes,centerscreen", obj);
            if (obj.result == 'No') return;
        }

        gTitle = gDoc.title;
        gTitle = gTitle.replace(/"/g, "'");
        if (gScrapBookisInstalled && (!(gURL2.substring(gURL2.length-4, gURL2.length) == '.txt'))) {
            this.SaveWithScrapBook(false, false);
        }
        else {
            this.SaveWithWRGet('/U "' + gURL2 + '" /T "' + gTitle + '"');
        }
    },

    
    SaveWebPageAs: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        var Frames = gDoc.getElementsByTagName('FRAME');
        var FrameCount = Frames.length;
        if (FrameCount > 0) {
            var obj = new Object();
            obj.result = "";
            window.openDialog("chrome://webresearch/content/frames.xul", 'foo_main', "chrome,dialog=yes,close,modal=yes,centerscreen", obj);
            if (obj.result == 'No') return;
        }

        gSaveType = 1;
        gTitle = gDoc.title;
        gTitle = gTitle.replace(/"/g, "'");
        if (gScrapBookisInstalled && (!(gURL2.substring(gURL2.length-4, gURL2.length) == '.txt'))) {
            this.SaveWithScrapBook(false, false);
        }
        else {
            this.SaveWithWRGet('/U "' + gURL2 + '" /T "' + gTitle + '" /SaveType 1');
        }

    },


    SaveScreenClipping: function() {
        this.SaveWithWRGet('/Clipping');
    },


    SaveAddressAs: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        this.SaveWithWRGet('/U "' + gURL2 + '" /T "' + gDoc.title + '" /DocType 300 /SaveType 32');
    },


    SaveCurrentFrame: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        // get focused window
        var myWindow = document.commandDispatcher.focusedWindow;
        if (!myWindow || myWindow == window) myWindow = window._content;
        var doc = myWindow.document;

        gURL2 = doc.location.href;
        gTitle = doc.title;
        gTitle = gTitle.replace(/"/g, "'");
        if (gScrapBookisInstalled) {
            this.SaveWithScrapBook(true, false);
        }
        else {
            this.SaveWithWRGet('/U "' + gURL2 + '" /T "' + gDoc.title + '" /DocType 100');
        }

    },


    SaveCurrentFrameAs: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        // get focused window
        var myWindow = document.commandDispatcher.focusedWindow;
        if (!myWindow || myWindow == window) myWindow = window._content;
        var doc = myWindow.document;

        gSaveType = 8;
        gURL2 = doc.location.href;
        gTitle = doc.title;
        gTitle = gTitle.replace(/"/g, "'");
        if (gScrapBookisInstalled) {
            this.SaveWithScrapBook(true, false);
        }
        else {
            this.SaveWithWRGet('/U "' + gURL2 + '" /T "' + gDoc.title + '" /DocType 100 /SaveType 8');
        }

    },


    SaveTarget: function() {
        var linkURL = gContextMenu.getLinkURL();
        if (!linkURL) return;

        this.SaveWithWRGet('/U "' + linkURL + '"');
    },


    SaveTargetAs: function() {
        var linkURL = gContextMenu.getLinkURL();
        if (!linkURL) return;

        this.SaveWithWRGet('/U "' + linkURL + '" /SaveType 16');
    },


    SaveAddressContext: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        this.SaveWithWRGet('/U "' + gContextMenu.getLinkURL() + '" /DocType 300 /SaveType 32');
    },


    SaveImage: function() {
        var imgElem = document.popupNode;

        if (imgElem) {
            if (this.PrepareSaving() == 1)  {
              return;
            }
            if (imgElem.alt)
              this.SaveWithWRGet('/U "' + imgElem.src + '" /T "' + imgElem.alt + '" /DocType 110');
            else
              this.SaveWithWRGet('/U "' + imgElem.src + '" /DocType 110');
        }
    },


    SaveImageAs: function() {
        var imgElem = document.popupNode;

        if (imgElem) {
            if (this.PrepareSaving() == 1)  {
              return;
            }
            if (imgElem.alt)
              this.SaveWithWRGet('/U "' + imgElem.src + '" /T "' + imgElem.alt + '" /DocType 110 /SaveType 2');
            else
              this.SaveWithWRGet('/U "' + imgElem.src + '" /DocType 110 /SaveType 2');
        }
    },


    SaveDroppedFile: function() {
        if (gDocType == 0) {
          if (gSaveType == 0)  {
            this.SaveWithWRGet('/U "' + gScrapBookPath + '" /RU "' + gURL2 + '" /T "' + gTitle + '"');
            }
          else {
            this.SaveWithWRGet('/U "' + gScrapBookPath + '" /RU "' + gURL2 + '" /T "' + gTitle + '" /SaveType ' + gSaveType);
            document.getElementById("statusbar-display").label = "";
            }
        }
        else {
          if (gSaveType == 0) {
            this.SaveWithWRGet('/U "' + gScrapBookPath + '" /RU "' + gURL2 + '" /T "' + gTitle + '" /DocType ' + gDocType);
            }
          else {
            this.SaveWithWRGet('/U "' + gScrapBookPath + '" /RU "' + gURL2 + '" /T "' + gTitle + '" /DocType ' + gDocType + ' /SaveType ' + gSaveType);
            document.getElementById("statusbar-display").label = "";
          }
        }
        
        // delete logical ScrapBook element	(no longer needed); the physical offline copy is still required and deleted by WRGet.exe after saving
        sbDataSource.clearContainer(gScrapBookFolder);
        gScrapBookPath = '';
    },


    SaveWithScrapBook: function(frame, selection) {

        // Callback-funktion sichern
        this.SBOnCaptureComplete = sbCaptureObserverCallback.onCaptureComplete;
        sbCaptureObserverCallback.onCaptureComplete = this.sbOnCaptureCompleteHook;

        // top.window.sbBrowserOverlay.execCapture : function(aPartialEntire, aFrameOnly, aShowDetail, aTargetID)
        // 'urn:scrapbook:root'
        var ret = null
        if (frame == false)
          if (selection == false)
            ret = sbBrowserOverlay.execCapture(0, null, false, gScrapBookFolder);
          else
            ret = sbBrowserOverlay.execCapture(1, null, false, gScrapBookFolder);
        else
            //sb.capture.frame:
            ret = sbBrowserOverlay.execCapture(2, true, false, gScrapBookFolder);

        var aFile = sbCommonUtils.getContentDir(sbContentSaver.item.id, true);
        var wrkRegistry = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
        wrkRegistry.open(wrkRegistry.ROOT_KEY_CURRENT_USER, "SOFTWARE\\macropool\\WebResearch\\CurrentSettings", wrkRegistry.ACCESS_WRITE);
        wrkRegistry.writeStringValue("FirefoxLastDocumentFileFolder", aFile.path);
        wrkRegistry.close();
        
        gScrapBookPath = aFile.path + "\\index.html";
    },


    SaveWithWRGet: function(parameters) {
        // find WebResearch installation directory
        var path = '';
        var subkey = null;
        var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
        wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\macropool", wrk.ACCESS_READ);
        if (wrk.hasChild("WebResearch")) {
            subkey = wrk.openChild("WebResearch", wrk.ACCESS_READ)
        }
        if (subkey == null) {
            // WebResearch 3 is not installed
            wrk.close();
            return;
        }
        var AppPath = subkey.readStringValue("AppPath");
        wrk.close();

        AppPath = AppPath + 'WRGet.exe';
        //
        // netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        try {
            var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath(AppPath);
            var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
            process.init(file);
            // run ( PRBool blocking , arrayof char* args , PRUint32 count ) 
            var args = [parameters];
            process.runw(false, args, args.length);
        } catch (e) {
            alert(e);
        }
    },

    CheckIfAlreadySaved: function() {
        if (this.PrepareSaving() == 1)  {
          return;
        }

        this.SaveWithWRGet('/checkifalreadysaved ' + gURL2);
    },

    ExamineLastSavedDocument: function() {
        this.SaveWithWRGet('/examinelastsaveddocument');
    },

    sbOnCaptureCompleteHook: function(aItem) {
        // restore original callback function
        sbCaptureObserverCallback.onCaptureComplete = WebResearch.SBOnCaptureComplete;
        sbCaptureObserverCallback.onCaptureComplete(aItem);
        // Save document in WebResearch
        WebResearch.SaveDroppedFile();
    }

};

